//////////////////////////////////////////////////////////////////////////////
//   ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "_DRAW_2D.h"
#include "_3D.h"

//////////////////////////////////////////////////////////////////////////////
//   ///////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
dwRGB r1 = RGBis(245, 100, 0), r2 = RGBis(135, 25, 0);

inline dwRGB getC(int i)
{ 
  if (i & 1)
  return r1;
  else
  return r2;
};

void Falloff(int f) { DrawRect(RegionFull(), RGBis(f,f,f), modeMUL); };

//////////////////////////////////////////////////////////////////////////////
//     /////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
TextSPR *info;

void CommonsInit()
{ RandomSeed();

  FC_FpsSet(AUTO);            //    
  FC_DrawPaint = Yes;         //  fps   DrawPaint();
  
  Draw2D_Init();
  ForceActivate();
  ScreenLoadWait();

  DrawClear();
};

void CommonsDone()
{
  delete info;
  Draw2D_Done();
};

//////////////////////////////////////////////////////////////////////////////////////////////////
int HelpTimer = 0;

void DrawInfo()
{
  tRegion r = RegionCenterIs(200, 120);
  DrawRegionStore.Save(r);
  DrawRect(r, RGBis(50, 50, 50), modeMUL); 
  info->Place(0, 0, modeADD + fromCC, "Control Keys:\n\n\nF1 - hide/show Help\n\nEsc - Exit"); info->Draw();
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void DrawAll()
{
  if (HelpTimer) DrawInfo();
  DrawPaint();
  if (HelpTimer) { DrawRegionStore.Restore();  HelpTimer--; };
};

inline void circle(tfloat x, tfloat y, tfloat r, dwRGB c, int i)
{
  dwRGB cc = RGBmultV(c, 55);
  DrawCircle(DrawXC + x, DrawYC + y, r, c);
  DrawCircle(DrawXC + x, DrawYC + y, r * 0.8, cc, modeADD);
  if (i) { DrawCircle(DrawXC - x, DrawYC - y, r, c);
           DrawCircle(DrawXC - x, DrawYC - y, r * 0.8, cc, modeADD);
           DrawCircle(DrawXC + x * 2.5, DrawYC + y * 2.5, r * 0.25, cc, modeADD);
           DrawCircle(DrawXC - x * 2.5, DrawYC - y * 2.5, r * 0.25, cc, modeADD);
           DrawCircle(DrawXC + x * 2.5, DrawYC + y * 2.5, r * 0.075, 0xffffffff);
           DrawCircle(DrawXC - x * 2.5, DrawYC - y * 2.5, r * 0.075, 0xffffffff);
         };
};

inline void circle2(tfloat x, tfloat y, tfloat r, dwRGB c, int i)
{
  DrawCircle(DrawXC + x * 3, DrawYC + y * 3, r * 7, c, modeMUL);
  if (i) DrawCircle(DrawXC - x * 3, DrawYC - y * 3, r * 7, c, modeMUL);
};

//////////////////////////////////////////////////////////////////////////////
//   //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void Main()
{
  CommonsInit();       //   ;  

  int bCount = 19;
  tfloat bRad = 70, bDist = 180, bSpeed = 0.5, bSpeedK = 3.75, bDistK = 0.85;

  tvect v;
  tfloat t;
  dwRGB c;   
  
  for (int i = 1; i < bCount; i++)
  { OBJ.Current(i);           
    COBJ->SetACenter(bDist * ((i - 1) != 0), 0, 0); 
    COBJ->SetSMap(0, 0, -1); COBJ->SetSCirc(M_PI / 600 / bSpeed);
    if (i > 1) COBJ->NextConv = i - 1;
    OBJ.Current(100 + i);           
    COBJ->SetACenter(0, bDist * ((i - 1) != 0), 0); 
    COBJ->SetSMap(0, 0, -1); COBJ->SetSCirc(M_PI / 600 / bSpeed);
    if (i > 1) COBJ->NextConv = 100 + i - 1;
  };

  while (Yes)
   { FC_Prepare();
     
     DrawClear();
     OBJs_RotateQDec();   
     for (int i = 1; i < bCount; i++)
     { OBJ.Current(i);
       v = COBJ->QConv(tvect(0, 0, 0));
       t = (tfloat)(i - 1) / bCount;
       c = getC(i);
       DrawCircle(DrawXC + v.x, DrawYC + v.y, bRad - t * bRad, c);
       if (i) DrawCircle(DrawXC - v.x, DrawYC - v.y, bRad - t * bRad, c);
       OBJ.Current(100 + i);
       v = COBJ->QConv(tvect(0, 0, 0));
       t = (tfloat)(i - 1) / bCount;
       c = getC(i);
       DrawCircle(DrawXC + v.x, DrawYC + v.y, bRad - t * bRad, c);
       if (i) DrawCircle(DrawXC - v.x, DrawYC - v.y, bRad - t * bRad, c);
     };
     DrawPaint();
     
     FC_FpsHold();
      
     if (II.AnyKeyUp)
     { if (II.KeyUp[_Esc_]) break;
       if (II.KeyUp[_F1_]) if (HelpTimer) HelpTimer = 0; else HelpTimer = 25 * 10;
       II.Reset();
     };
   };   
  CommonsDone();       //   ;
};

//////////////////////////////////////////////////////////////////////////////
void Main2()
{
  CommonsInit();       //   ;  

  int bCount = 19;
  tfloat bRad = 70, bDist = 180, bSpeed = 0.5, bSpeedK = 3.75, bDistK = 0.85;

  //int bCount = 17;
  //tfloat bRad = 90, bDist = 120, bSpeed = 0.75, bSpeedK = 3.75, bDistK = 0.75;

  //int bCount = 21;
  //tfloat bRad = 55, bDist = 120, bSpeed = 1.15, bSpeedK = 25.75, bDistK = 0.75;

  //int bCount = 11;
  //tfloat bRad = 150, bDist = 550, bSpeed = 0.5, bSpeedK = 1.75, bDistK = 1;


  tvect v, v0 = tvect(0, 0, 0);
  tfloat t, t2, r, k = (tfloat)DrawYR / 1024;
  dwRGB c;
  bRad *= k; bDist *= k; 
   
  for (int i = 1; i < bCount; i++)
  { t = (tfloat)(i - 1) / bCount;
    OBJ.Current(i);           
    COBJ->SetACenter(bDist * ((i - 1) != 0), 0, 0); 
    COBJ->SetSMap(0, 0, -1); COBJ->SetSCirc(M_PI / 600 * bSpeed);
    if (i > 1) COBJ->NextConv = i - 1;
    for (int j = 2; j < bCount; j++)
    { OBJ.Current(1000 + i * bCount + j);           
      COBJ->SetACenter(0, bDist * (1 - t) * bDistK, 0); 
      COBJ->SetSMap(0, 0, -1); COBJ->SetSCirc(M_PI / 600 * bSpeed * bSpeedK);
      if (j == 2) COBJ->NextConv = i; else COBJ->NextConv = 1000 + i * bCount + j - 1; 
      OBJ.Current(8000 + i * bCount + j);           
      COBJ->SetACenter(0, -bDist * (1 - t) * bDistK, 0); 
      COBJ->SetSMap(0, 0, -1); COBJ->SetSCirc(M_PI / 600 * bSpeed * bSpeedK);
      if (j == 2) COBJ->NextConv = i; else COBJ->NextConv = 8000 + i * bCount + j - 1; 
    };/**/
    
  };

  while (Yes)
   { //DrawClear();
     DrawFill(RGBmultV(r2, 155));
     //Falloff(127);
     
     /*if (Random(77) == 11)
     for (int i = 1; i < bCount; i++)
     { OBJ.Current(i); COBJ->SetSMap(0, 0, -COBJ->SMap.Vz);
     };*/
     
     OBJs_RotateQDec();   
     
     for (int i = 2; i < bCount; i += 2)
     { OBJ.Current(i);
       v = COBJ->QConv(v0);
       t = 1 - (tfloat)(i - 1) / (bCount - 10);
       c = getC(i); r = bRad * t;
       circle2(v.x, v.y, r, r2, i - 1);
     };/**/
     for (int i = 1; i < bCount; i++)
     { OBJ.Current(i);
       v = COBJ->QConv(v0);
       t = 1 - (tfloat)(i - 1) / bCount;
       c = getC(i); r = bRad * t;
       circle(v.x, v.y, r, c, i - 1);
       for (int j = 2; j < bCount; j++)
       { c = getC(i + j + 1); t2 = (1 - (tfloat)(j - 1) / bCount) * t; r = bRad * t2;
         OBJ.Current(1000 + i * bCount + j);        
         v = COBJ->QConv(v0);
         circle(v.x, v.y, r, c, i - 1);
         OBJ.Current(8000 + i * bCount + j);          
         v = COBJ->QConv(v0);    
         circle(v.x, v.y, r, c, i - 1);
       };/**/
       
     };
     DrawPaint();
      
     if (II.AnyKeyUp)
     { if (II.KeyUp[_Esc_]) break;
       if (II.KeyUp[_F1_]) if (HelpTimer) HelpTimer = 0; else HelpTimer = 25 * 10;
       II.Reset();
     };
   };   

  CommonsDone();       //   ;
};

//////////////////////////////////////////////////////////////////////////////
int LetProcess()
{
  WinName = L"cg_HRotation";          //    
  VS_BColor = RGBis(25,25,25); //   
  VS_CColor = RGBis(0,0,0);    //   
  DrawSet(FullScreen);         //   ( )  , FullScreen   
  //DrawSet(240,240);
  ProcessFunc = Main2;           //    -  
  return on;
};
int Init_LetProcess = LetProcess();

